package com.vendor.burn.ui.burners;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.burn.Activator;
import com.vendor.burn.Messages;
import com.vendor.burn.model.PartitionInfo;
import com.vendor.burn.model.PartitionItem;
import com.vendor.burn.model.define.IBurner;
import com.vendor.burn.model.devices.IOneImageBurner;
import com.vendor.burn.model.event.FastbootEvent;
import com.vendor.burn.model.event.IFastbootEventListener;
import com.vendor.burn.serial.workers.CallLibBootromWorker;
import com.vendor.burn.serial.workers.WorkerUtility;
import com.vendor.burn.ui.BurnComposite;
import com.vendor.burn.utilitily.ToolUtils;
import com.vendor.burn.views.FastbootView;
import java.io.File;
import java.util.List;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.layout.TableColumnLayout;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.CheckboxTableViewer;
import org.eclipse.jface.viewers.ColumnLayoutData;
import org.eclipse.jface.viewers.ColumnPixelData;
import org.eclipse.jface.viewers.ColumnWeightData;
import org.eclipse.jface.viewers.IBaseLabelProvider;
import org.eclipse.jface.viewers.ICellModifier;
import org.eclipse.jface.viewers.ICheckStateListener;
import org.eclipse.jface.viewers.IContentProvider;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TextCellEditor;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Layout;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Widget;

public class OneImageComposite extends BurnComposite implements IFastbootEventListener {
  private static final int COL_SEL = 0;
  
  private static final int COL_FILE_PARTITION = 1;
  
  private static final int COL_SIZE = 2;
  
  private static final int COL_ADDRESS = 3;
  
  private static final String[] COLUMNS = new String[] { Messages.PartitionComposite_TABLE_COLOMN_SEL, Messages.tableColumnFilePartition, Messages.tableColumnSizeByte, Messages.tableColumnTargetBurnAddress };
  
  private CheckboxTableViewer itemViewer;
  
  private Button burnButton;
  
  private Text tableFileText;
  
  private Button browseButton;
  
  private TabItem tabItem;
  
  private Control tableControl;
  
  private Composite com;
  
  private CheckboxTableViewer viewer;
  
  public OneImageComposite(Composite parent, int style, IBurner burner) {
    super(parent, style, burner);
  }
  
  protected void createContents(Composite parent) {
    parent.setLayout((Layout)new FillLayout());
    this.com = new Composite(parent, 0);
    this.com.setLayout((Layout)new GridLayout(6, false));
    GridData gridData = new GridData(1808);
    this.com.setLayoutData(gridData);
    Label label = new Label(this.com, 0);
    GridData layoutData = new GridData(1, 1, false, false);
    layoutData.horizontalIndent = 20;
    label.setLayoutData(layoutData);
    label.setText(Messages.imageFilePath);
    this.tableFileText = new Text(this.com, 2048);
    GridData tableFileTextGD = new GridData(4, 1, true, false);
    tableFileTextGD.horizontalIndent = 5;
    tableFileTextGD.horizontalSpan = 2;
    this.tableFileText.setLayoutData(tableFileTextGD);
    this.tableFileText.addListener(14, (Listener)new Object(this));
    this.browseButton = new Button(this.com, 0);
    this.browseButton.setImage(Activator.getImage("icons/selfile.ico"));
    layoutData = new GridData(1, 1, false, false);
    ToolUtils.setWidthForOS(layoutData, 60, 70);
    this.browseButton.setLayoutData(layoutData);
    this.browseButton.addListener(13, (Listener)new Object(this));
    this.tableControl = createItemTable(this.com);
    if (this.tableControl.getData() instanceof CheckboxTableViewer)
      this.itemViewer = (CheckboxTableViewer)this.tableControl.getData(); 
    this.itemViewer.setInput(getBurner());
    createButtons(this.com);
    GridData layoutData2 = new GridData(4, 4, true, false, 6, 1);
    layoutData2.heightHint = 100;
    this.tableControl.setLayoutData(layoutData2);
  }
  
  private void createButtons(Composite parent) {
    Composite buttonComp = new Composite(parent, 0);
    buttonComp.setLayout((Layout)new GridLayout(5, true));
    this.burnButton = new Button(buttonComp, 0);
    this.burnButton.setText(Messages.startBurning);
    GridData layoutData = new GridData(4, 16777216, false, true, 1, 1);
    layoutData.widthHint = 120;
    this.burnButton.setLayoutData(layoutData);
    this.burnButton.addListener(13, (Listener)new Object(this));
    buttonComp.setLayoutData(new GridData(4, 1, true, false, 4, 1));
  }
  
  private void handleEnterOnTableFileText() {
    if (this.tableFileText == null || this.tableFileText.isDisposed())
      return; 
    String text = this.tableFileText.getText().trim();
    File file = new File(text);
    if (!file.exists()) {
      handleBrowseFile();
    } else {
      loadPartitionFile(text);
    } 
  }
  
  private void handleBrowseFile() {
    FileDialog dialog = new FileDialog(getShell(), 4096);
    dialog.setFilterExtensions(new String[] { "*.bin" });
    String text = this.tableFileText.getText();
    if (!text.equals(""))
      dialog.setFileName(text); 
    String filePath = dialog.open();
    if (filePath != null) {
      loadPartitionFile(filePath);
      this.tableFileText.setText(filePath);
    } 
  }
  
  private void loadPartitionFile(String fileName) {
    CallLibBootromWorker.setChipType(FastbootView.getDepartmentNumber(this.burner), 
        FastbootView.getChipType(this.burner));
    String[] fileInfo = CallLibBootromWorker.resolveAllinoneImage(fileName);
    PartitionInfo partitionInfo = getBurner().getPratitionInfo();
    List<PartitionItem> child = partitionInfo.getChildren();
    if (fileInfo.length <= 0) {
      PartitionItem item = new PartitionItem();
      item.setName(fileName);
      File file = new File(fileName);
      item.setLength(file.length());
      item.setStart(0L);
      item.setChecked(true);
      child.add(item);
    } else {
      int i;
      int len;
      for (i = 0, len = child.size(); i < len; i++) {
        if (((PartitionItem)child.get(i)).isInAllinone()) {
          child.remove(i);
          len--;
          i--;
        } 
      } 
      for (i = 0; i < fileInfo.length; i++) {
        if (!fileInfo[i].isEmpty()) {
          String[] aloneInfo = fileInfo[i].trim().split(",");
          if (!"0".equals(aloneInfo[0])) {
            PartitionItem item = new PartitionItem();
            item.setName(aloneInfo[0]);
            item.setChecked(true);
            item.setLength(WorkerUtility.ReceiveHelper.convertToNumber(aloneInfo[1]));
            item.setStart(WorkerUtility.ReceiveHelper.convertToNumber(aloneInfo[2]));
            item.setInAllinone(true);
            item.setAllinoneFileIndex((int)WorkerUtility.ReceiveHelper.convertToNumber(aloneInfo[3]));
            child.add(item);
          } 
        } 
      } 
      getBurner().setHasAllinone(true);
    } 
    if (child.size() <= 13) {
      GridData layoutData = new GridData(4, 4, true, false, 6, 1);
      layoutData.heightHint = 25 + child.size() * 23;
      this.tableControl.setLayoutData(layoutData);
    } 
    this.itemViewer.refresh();
    this.com.layout();
    updateSelection();
  }
  
  private void updateSelection() {
    TableItem[] items = this.itemViewer.getTable().getItems();
    for (TableItem tableItem : items) {
      if (tableItem.getData() instanceof PartitionItem) {
        PartitionItem data = (PartitionItem)tableItem.getData();
        tableItem.setChecked(data.isChecked());
      } 
    } 
  }
  
  private Control createItemTable(Composite parent) {
    Composite control = new Composite(parent, 2048);
    TableColumnLayout tcl = new TableColumnLayout();
    control.setLayout((Layout)tcl);
    this.viewer = CheckboxTableViewer.newCheckList(control, 66064);
    this.viewer.setContentProvider(createContentProvider());
    this.viewer.setLabelProvider(createLabelProvider());
    Table table = this.viewer.getTable();
    table.setHeaderVisible(true);
    table.setLinesVisible(true);
    addTableColumn(tcl, table);
    this.viewer.setColumnProperties(COLUMNS);
    this.viewer.setCellModifier((ICellModifier)new Object(this));
    TextCellEditor nameEditor = new TextCellEditor((Composite)table);
    TextCellEditor startEditor = new TextCellEditor((Composite)table);
    TextCellEditor lengthEditor = new TextCellEditor((Composite)table);
    this.viewer.setCellEditors(new CellEditor[] { null, (CellEditor)nameEditor, (CellEditor)lengthEditor, (CellEditor)startEditor });
    control.setData(this.viewer);
    return (Control)control;
  }
  
  private void addTableColumn(TableColumnLayout tcl, Table table) {
    TableColumn column = new TableColumn(table, 16777216, 0);
    column.setImage(Activator.getImage("icons/check.bmp"));
    column.setResizable(false);
    column.setMoveable(false);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnPixelData(35, false));
    column.addListener(13, (Listener)new Object(this));
    this.viewer.addCheckStateListener((ICheckStateListener)new Object(this));
    int minWeidth = 35;
    column = new TableColumn(table, 16777216, 1);
    column.setResizable(false);
    column.setMoveable(false);
    column.setText(COLUMNS[1]);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(4, 35, false));
    column = new TableColumn(table, 16384, 2);
    column.setResizable(false);
    column.setMoveable(false);
    column.setText(COLUMNS[2]);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(4, 35, false));
    column = new TableColumn(table, 16777216, 3);
    column.setResizable(false);
    column.setMoveable(false);
    column.setText(COLUMNS[3]);
    column.setAlignment(16777216);
    tcl.setColumnData((Widget)column, (ColumnLayoutData)new ColumnWeightData(3, 35, false));
  }
  
  private boolean canBeModify(Object element, String property) {
    PartitionItem value = null;
    if (element instanceof PartitionItem) {
      value = (PartitionItem)element;
    } else if (element instanceof TableItem) {
      TableItem table = (TableItem)element;
      if (table.getData() instanceof PartitionItem)
        value = (PartitionItem)table.getData(); 
    } else {
      return false;
    } 
    if (value != null && (
      property.equals(COLUMNS[3]) || property.equals(COLUMNS[0])))
      return true; 
    return false;
  }
  
  private Object getTableValue(Object element, String property) {
    PartitionItem value = null;
    if (element instanceof PartitionItem) {
      value = (PartitionItem)element;
    } else if (element instanceof TableItem) {
      TableItem table = (TableItem)element;
      if (table.getData() instanceof PartitionItem)
        value = (PartitionItem)table.getData(); 
    } else {
      return "";
    } 
    if (value != null && 
      property.equals(COLUMNS[3]))
      return "0x" + Long.toHexString(value.getStart()); 
    return value;
  }
  
  private void modifyTable(Object element, String property, Object value) {
    PartitionItem item = null;
    if (element instanceof PartitionItem) {
      item = (PartitionItem)element;
    } else if (element instanceof TableItem) {
      TableItem table = (TableItem)element;
      if (table.getData() instanceof PartitionItem)
        item = (PartitionItem)table.getData(); 
    } else {
      return;
    } 
    if (item != null) {
      if (property.equals(COLUMNS[3])) {
        long convertToNumber;
        String valueStr = value.toString();
        if (valueStr.startsWith("0x") || valueStr.startsWith("0X")) {
          convertToNumber = WorkerUtility.ReceiveHelper.convertToNumber(valueStr);
        } else {
          MessageDialog.openError(Display.getDefault().getActiveShell(), "Error", Messages.pleaseInput16BurnAddress);
          return;
        } 
        if (convertToNumber != item.getStart())
          item.setStart(convertToNumber); 
      } 
      this.viewer.refresh();
    } 
  }
  
  private IBaseLabelProvider createLabelProvider() {
    return (IBaseLabelProvider)new ViewerLabelProvider(this);
  }
  
  private IContentProvider createContentProvider() {
    return (IContentProvider)new ViewerContentProvider();
  }
  
  protected Layout createLayout() {
    return (Layout)new GridLayout(4, false);
  }
  
  private boolean isAllChecked() {
    Object[] checkedElements = this.itemViewer.getCheckedElements();
    return (checkedElements.length == getBurner().getPratitionInfo().getChildren().size());
  }
  
  public void finished(FastbootEvent event) {
    super.finished(event);
  }
  
  protected void disableUI() {
    if (this.burnButton != null && !this.burnButton.isDisposed())
      this.burnButton.setEnabled(false); 
    if (this.browseButton != null && !this.browseButton.isDisposed())
      this.browseButton.setEnabled(false); 
  }
  
  protected void enableButtons() {
    if (this.burnButton != null && !this.burnButton.isDisposed())
      this.burnButton.setEnabled(true); 
    if (this.browseButton != null && !this.browseButton.isDisposed())
      this.browseButton.setEnabled(true); 
  }
  
  protected void enableUI() {
    enableButtons();
  }
  
  public void hightLight(List<PartitionItem> parts) {
    if (parts.isEmpty())
      return; 
    if (!isDisposed() && 
      this.itemViewer != null) {
      this.itemViewer.setSelection((ISelection)new StructuredSelection(parts), true);
      this.itemViewer.getControl().getParent().setFocus();
    } 
  }
  
  public IOneImageBurner getBurner() {
    IBurner burner = super.getBurner();
    if (burner instanceof IOneImageBurner)
      return (IOneImageBurner)burner; 
    return null;
  }
  
  public void setTabItem(TabItem tabItem) {
    this.tabItem = tabItem;
  }
}
